import java.util.ArrayList;
import java.util.HashSet;
import java.util.TreeSet;

public class Main {
    public static void main(String[] args) {
        // Przykłady do przetestowania:
        ArrayList<Integer> exampleList = new ArrayList<>();
        exampleList.add(4);
        exampleList.add(2);
        exampleList.add(6);
        exampleList.add(17);
        exampleList.add(10);
        TreeSet<Integer> exampleTreeSet = new TreeSet<>();
        exampleTreeSet.addAll(exampleList); // dodajemy wszystkie elementy z przekazanej parametrem kolekcji
        HashSet<Integer> exampleHashSet = new HashSet<>();
        exampleHashSet.addAll(exampleList);
        System.out.println("exampleTreeSet " + exampleTreeSet); // TreeSet - elementy wyświetlone w domyślnym porządku naturalnym
        System.out.println("exampleHashSet " + exampleHashSet); // HashSet - brak gwarancji kolejności wyświetlania elementów

        // dodajemy kolejne elementy:
        exampleTreeSet.add(15);
        exampleTreeSet.add(-5);
        exampleHashSet.add(15);
        exampleHashSet.add(-5);
        System.out.println("exampleTreeSet " + exampleTreeSet); // natural order, elementy 15 i -5 są uporządkowane
        System.out.println("exampleHashSet " + exampleHashSet); // random order, elementy nie są posortowane

        System.out.println("After adding number 6 once again");
        exampleTreeSet.add(6);
        exampleHashSet.add(6);
        System.out.println("exampleTreeSet " + exampleTreeSet); // brak duplikatów !
        System.out.println("exampleHashSet " + exampleHashSet); // brak duplikatów !

        // brak metody get oraz add(index,element) - Set nie posiada indeksacji
        // brak metod pozwalających na pobranie elementu z setu używajac indeksów

        System.out.println("exampleTreeSet content:");
        for(int setItem : exampleTreeSet){
            System.out.println(setItem);
        }

        System.out.println("exampleHashSet content:");
        for(int setItem : exampleHashSet){
            System.out.println(setItem);
        }

        // zadanie 1
        TreeSet<Double> gradesSet = Grades.getGradesSetAsTreeSet(); // TreeSet
        System.out.println("gradesTreeSet " + gradesSet);

        HashSet<Double> gradesHashSet = Grades.getGradesSetAsHashSet(); // HashSet
        System.out.println("gradesHashSet " + gradesHashSet);

        TreeSet<Double> gradesSetVs2 = Grades.getGradesTreeSetVs2(); // TreeSet
        System.out.println("getGradesTreeSetVs2 " + gradesSetVs2);

        ArrayList<Double> studentGrades = new ArrayList();
        studentGrades.add(4.5);
        studentGrades.add(4.5);
        studentGrades.add(4.0);
        studentGrades.add(3.5);
        System.out.println("showUniqueGradesAsHashSet");
        for(double grade : Grades.showUniqueGradesAsHashSet(studentGrades)){
            System.out.println(grade);
        }
        System.out.println("showUniqueGradesAsTreeSet");
        for(double grade : Grades.showUniqueGradesAsTreeSet(studentGrades)){
            System.out.println(grade);
        }

        // zadanie 2
        System.out.println(WordsHelper.returnUniqueWords("HelloWord"));
        System.out.println(WordsHelper.returnUniqueWords("Hello"));
        System.out.println(WordsHelper.countUniqueWords("Hello"));


    }
}